<template>
  <div>
    <v-row dense>
      <GCol cols="12">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12">
        <DccLocalizedTextarea
          v-model="value.name"
          i18n="dcc.common.refTypeDefinitionType.name"
          validate="required"
        />
      </GCol>
      <GCol cols="12">
        <RichContent
          v-if="value.description"
          ref="description"
          v-model="value.description"
          i18n="dcc.common.refTypeDefinitionType.description.title"
          optional
          level="second"
          @delete="deleteRichContent()"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.namespace"
          i18n="dcc.common.refTypeDefinitionType.namespace"
          validate="required notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.link"
          i18n="dcc.common.refTypeDefinitionType.link"
          validate="required notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.release"
          i18n="dcc.common.refTypeDefinitionType.release"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.value"
          i18n="dcc.common.refTypeDefinitionType.value"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.procedure"
          i18n="dcc.common.refTypeDefinitionType.procedure"
          validate="notEmptyStringType"
        />
      </GCol>
    </v-row>
  </div>
</template>
<script>
import { DCCXMLElement, RichContentType } from "@d-ptb/dcc-js";
import RichContent from "~/components/DCC/Common/RichContent.vue";
import XmlTextField from "~/components/App/Form/XML/XmlTextField";
import DccLocalizedTextarea from "~/components/App/Form/XML/DccLocalizedTextarea";
import GCol from "~/components/App/Common/GCol";
import { insertIf } from "~/assets/util/general";
import GTextField from "~/components/App/Form/gTextField";

export default {
  name: "RefTypeDefinition",
  components: {
    GTextField,
    GCol,
    RichContent,
    XmlTextField,
    DccLocalizedTextarea,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
  },
  data() {
    return {};
  },
  computed: {
    availableElements() {
      return [
        {
          text: this.$t(`dcc.common.richContentType.description.title`),
          value: "description",
          addElement: () => this.addElement("description"),
        },
      ].filter((x) => !this.blacklist.includes(x.value));
    },
    blacklist() {
      return [...insertIf(this.value.description, "description")];
    },
    type: {
      get() {
        return this.value.type ? this.value.type._text : "";
      },
      set(val) {
        if (val) {
          this.value.type = new DCCXMLElement({ _text: val });
        } else {
          this.value.type = null;
        }
      },
    },
  },
  watch: {
    availableElements: {
      handler() {
        this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "description":
          this.$set(this.value, "description", new RichContentType());
          break;
      }
      this.$nextTick(() => {
        this.$refs[element].$el.scrollIntoView({
          behavior: "smooth",
        });
      });
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
  },
};
</script>
